freedomboneeee/src/freedombone-app-tahoelafs

330 lines
11 KiB
Plaintext
Raw Normal View History

2016-08-28 00:40:21 +02:00
#!/bin/bash
#
# .---. . .
# | | |
# |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
# | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
# ' ' --' --' -' - -' ' ' -' -' -' ' - --'
#
# Freedom in the Cloud
#
2017-03-04 00:25:38 +01:00
# Distributed storage system introducer
# http://tahoe-lafs.readthedocs.io/en/latest/anonymity-configuration.html
2016-08-28 00:40:21 +02:00
#
# License
# =======
#
2016-10-31 17:24:49 +01:00
# Copyright (C) 2014-2016 Bob Mottram <bob@freedombone.net>
2016-08-28 00:40:21 +02:00
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
2017-03-03 19:48:33 +01:00
VARIANTS='full full-vim cloud'
2016-08-28 00:40:21 +02:00
IN_DEFAULT_INSTALL=0
2017-03-05 13:10:58 +01:00
SHOW_ON_ABOUT=1
TAHOELAFS_REPO="https://github.com/tahoe-lafs/tahoe-lafs"
2017-03-03 19:48:33 +01:00
TAHOELAFS_COMMIT='bb782b0331a60de438136a593bba18338d8d866b'
2016-08-28 00:40:21 +02:00
TAHOELAFS_PORT=50213
2017-03-05 13:09:45 +01:00
TAHOELAFS_WEB_PORT=50214
2017-03-04 00:25:38 +01:00
TAHOELAFS_ONION_PORT=8096
2017-03-03 19:56:32 +01:00
2016-08-28 00:40:21 +02:00
TAHOELAFS_SHARED_DIR='Shared'
2017-03-04 19:18:07 +01:00
TAHOE_COMMAND="cd /home/tahoelafs/tahoelafs && venv/bin/tahoe"
2016-08-28 00:40:21 +02:00
2017-03-04 00:25:38 +01:00
tahoelafs_variables=(ONION_ONLY
TAHOELAFS_REPO
2016-10-05 23:33:41 +02:00
TAHOELAFS_PORT)
2017-03-04 00:25:38 +01:00
function tahoelafs_setup_config {
config_file=$1
if ! grep -q "[node]" $config_file; then
echo '' >> $config_file
echo '[node]' >> $config_file
fi
if ! grep -q "[connections]" $config_file; then
echo '' >> $config_file
echo '[connections]' >> $config_file
fi
if ! grep -q "reveal-IP-address" $config_file; then
sed -i '/[node]/a reveal-IP-address = False' $config_file
else
2017-03-04 23:55:30 +01:00
sed -i 's|reveal-IP-address.*|reveal-IP-address = False|g' $config_file
2017-03-04 00:25:38 +01:00
fi
if ! grep -q "tcp =" $config_file; then
sed -i '/[connections]/a tcp = tor' $config_file
else
2017-03-04 23:55:30 +01:00
sed -i 's|tcp =.*|tcp = tor|g' $config_file
2017-03-04 00:25:38 +01:00
fi
if ! grep -q "tub.location =" $config_file; then
2017-03-04 23:55:30 +01:00
sed -i '/[node]/a tub.location = disabled' $config_file
2017-03-04 00:25:38 +01:00
fi
if ! grep -q "tub.port =" $config_file; then
2017-03-04 23:55:30 +01:00
sed -i "/[node]/a tub.port = tcp:${TAHOELAFS_ONION_PORT}:interface=127.0.0.1" $config_file
2017-03-04 00:25:38 +01:00
fi
2017-03-04 23:55:30 +01:00
sed -i "s|tub.port.*|tub.port = tcp:${TAHOELAFS_ONION_PORT}:interface=127.0.0.1|g" $config_file
sed -i "s|tub.location.*|tub.location = tor:${TAHOELAFS_ONION_HOSTNAME}:${TAHOELAFS_PORT}|g" $config_file
2017-03-04 00:25:38 +01:00
sed -i "s|nickname =.*|nickname = $HOSTNAME|g" $config_file
2017-03-05 13:09:45 +01:00
sed -i "s|web.port =.*|web.port = tcp:$TAHOELAFS_WEB_PORT:interface=127.0.0.1|g" $config_file
2017-03-04 00:25:38 +01:00
if ! grep -q "[storage]" $config_file; then
echo '' >> $config_file
echo '[storage]' >> $config_file
echo 'enabled = false' >> $config_file
fi
}
function install_interactive_tahoelafs {
echo -n ''
APP_INSTALLED=1
}
2016-08-28 00:40:21 +02:00
function upgrade_tahoelafs {
2017-03-03 19:48:33 +01:00
systemctl stop tahoelafs
function_check set_repo_commit
set_repo_commit /home/tahoelafs/tahoelafs "tahoelafs commit" "$TAHOELAFS_COMMIT" $TAHOELAFS_REPO
cd /home/tahoelafs/tahoelafs
2017-03-04 18:49:44 +01:00
git submodule update --init --recursive
2017-03-03 19:48:33 +01:00
virtualenv venv
venv/bin/pip install --editable .
2017-03-04 16:36:58 +01:00
chown -R tahoelafs:tahoelafs /home/tahoelafs
2017-03-03 19:48:33 +01:00
systemctl start tahoelafs
2016-08-28 00:40:21 +02:00
}
function backup_local_tahoelafs {
2017-03-04 22:02:02 +01:00
source_directory=/home/tahoelafs/data
2016-08-29 12:04:37 +02:00
if [ ! -d $source_directory ]; then
return
fi
systemctl stop tahoelafs
dest_directory=tahoelafs
function_check backup_directory_to_usb
backup_directory_to_usb $source_directory $dest_directory
systemctl start tahoelafs
2016-08-28 00:40:21 +02:00
}
function restore_local_tahoelafs {
2016-08-29 12:04:37 +02:00
echo $"Restoring Tahoe-LAFS introducer"
systemctl stop tahoelafs
temp_restore_dir=/root/temptahoelafs
restore_directory_from_usb $temp_restore_dir tahoelafs
2017-03-04 22:02:02 +01:00
mv /home/tahoelafs/data /home/tahoelafs/data-old
cp -r $temp_restore_dir/home/tahoelafs/data /home/tahoelafs/data
2016-08-29 12:21:39 +02:00
if [ ! "$?" = "0" ]; then
2017-03-04 22:02:02 +01:00
mv /home/tahoelafs/data-old /home/tahoelafs/data
2016-08-29 12:21:39 +02:00
exit 246833
fi
2017-03-04 22:02:02 +01:00
rm -rf /home/tahoelafs/data
2016-08-29 12:04:37 +02:00
chown -R tahoelafs:tahoelafs /home/tahoelafs
systemctl start tahoelafs
2016-08-29 12:21:39 +02:00
echo $"Restore complete"
2016-08-28 00:40:21 +02:00
}
function backup_remote_tahoelafs {
2017-03-04 22:02:02 +01:00
source_directory=/home/tahoelafs/data
2016-08-29 12:21:39 +02:00
if [ ! -d $source_directory ]; then
return
fi
systemctl stop tahoelafs
dest_directory=tahoelafs
function_check backup_directory_to_usb
backup_directory_to_friend $source_directory $dest_directory
systemctl start tahoelafs
2016-08-28 00:40:21 +02:00
}
function restore_remote_tahoelafs {
2016-08-29 12:21:39 +02:00
echo $"Restoring Tahoe-LAFS introducer"
systemctl stop tahoelafs
temp_restore_dir=/root/temptahoelafs
restore_directory_from_friend $temp_restore_dir tahoelafs
2017-03-04 22:02:02 +01:00
mv /home/tahoelafs/data /home/tahoelafs/data-old
cp -r $temp_restore_dir/home/tahoelafs/data /home/tahoelafs/data
2016-08-29 12:21:39 +02:00
if [ ! "$?" = "0" ]; then
2017-03-04 22:02:02 +01:00
mv /home/tahoelafs/data-old /home/tahoelafs/data
2016-08-29 12:21:39 +02:00
exit 623925
fi
2017-03-04 22:02:02 +01:00
rm -rf /home/tahoelafs/data-old
2016-08-29 12:21:39 +02:00
chown -R tahoelafs:tahoelafs /home/tahoelafs
systemctl start tahoelafs
echo $"Restore complete"
2016-08-28 00:40:21 +02:00
}
2017-03-04 00:30:55 +01:00
function reconfigure_tahoelafs {
echo -n ''
}
2016-08-28 00:40:21 +02:00
function remove_tahoelafs {
2017-03-05 13:09:45 +01:00
if [ -f /etc/nginx/sites-available/tahoelafs ]; then
nginx_dissite tahoelafs
rm /etc/nginx/sites-available/tahoelafs
if [ -d /var/www/tahoelafs ]; then
rm -rf /var/www/tahoelafs
fi
systemctl reload nginx
fi
2017-03-04 18:52:15 +01:00
systemctl stop tahoelafs
systemctl disable tahoelafs
rm /etc/systemd/system/tahoelafs.service
2016-10-22 11:39:34 +02:00
firewall_remove ${TAHOELAFS_PORT}
rm -rf /var/lib/tahoelafs
2016-10-17 15:44:49 +02:00
remove_completion_param install_tahoelafs
remove_completion_param configure_firewall_for_tahoelafs
2017-03-04 00:25:38 +01:00
function_check remove_onion_service
remove_onion_service tahoelafs ${TAHOELAFS_ONION_PORT}
deluser tahoelafs
2017-03-04 18:52:15 +01:00
if [ -d /home/tahoelafs ]; then
rm -rf /home/tahoelafs
fi
2017-03-04 00:28:52 +01:00
remove_app tahoelafs
2016-08-28 00:40:21 +02:00
}
function configure_firewall_for_tahoelafs {
2016-10-16 20:50:56 +02:00
if [[ $(is_completed $FUNCNAME) == "1" ]]; then
2016-08-28 00:40:21 +02:00
return
fi
2016-10-22 11:39:34 +02:00
firewall_add Tahoe-LAFS ${TAHOELAFS_PORT}
2016-10-16 20:50:56 +02:00
mark_completed $FUNCNAME
2016-08-28 00:40:21 +02:00
}
function install_tahoelafs {
if [ $INSTALLING_MESH ]; then
return
fi
2017-03-04 18:49:44 +01:00
apt-get -yq install build-essential python-pip python-dev libffi-dev libssl-dev
2017-03-04 19:18:07 +01:00
apt-get -yq install libcrypto++-dev python-pycryptopp python-cffi python-virtualenv
# create a user to run the introducer
if [ ! -d /home/tahoelafs ]; then
# add a gogs user account
adduser --disabled-login --gecos 'tahoe-lafs' tahoelafs
fi
if [ -d /home/tahoelafs/Maildir ]; then
rm -rf /home/tahoelafs/Maildir
fi
git_clone $TAHOELAFS_REPO /home/tahoelafs/tahoelafs
cd /home/tahoelafs/tahoelafs
git checkout $TAHOELAFS_COMMIT -b $TAHOELAFS_COMMIT
2017-03-04 18:49:44 +01:00
git submodule update --init --recursive
2017-03-04 21:41:48 +01:00
virtualenv venv --distribute
2017-03-04 21:49:49 +01:00
venv/bin/pip uninstall --yes setuptools
2017-03-04 20:42:13 +01:00
venv/bin/pip install setuptools==11.3
2017-03-04 20:40:24 +01:00
venv/bin/pip install six==1.10.0 packaging==16.8 attrs==16.3.0 appdirs==1.4.2 pycrypto==2.1.0 cffi==1.9.1
2017-03-04 21:41:48 +01:00
venv/bin/pip install cryptography==1.7.2 markerlib==0.6.0 distribute==0.7.3
2017-03-05 00:09:40 +01:00
venv/bin/pip install txtorcon==0.18.0
venv/bin/pip install --editable .
2016-08-28 00:40:21 +02:00
configure_firewall_for_tahoelafs
2017-03-04 21:49:49 +01:00
if [ -d /home/tahoelafs/data ]; then
rm -rf /home/tahoelafs/data
2017-03-04 21:41:48 +01:00
fi
2017-03-04 21:49:49 +01:00
mkdir /home/tahoelafs/data
2017-03-04 21:45:19 +01:00
# remove files we don't need
2017-03-04 21:49:49 +01:00
rm -rf /home/tahoelafs/.mutt
2017-03-04 21:45:19 +01:00
rm /home/tahoelafs/.emacs-mutt
rm /home/tahoelafs/.muttrc
rm /home/tahoelafs/.mutt-alias
rm /home/tahoelafs/.procmailrc
# set permissions
2017-03-04 21:41:48 +01:00
chown -R tahoelafs:tahoelafs /home/tahoelafs
2017-03-04 21:45:19 +01:00
# create the introducer config
2017-03-04 21:41:48 +01:00
su -c "$TAHOE_COMMAND create-introducer -C /home/tahoelafs/data --hide-ip --hostname=127.0.0.1" - tahoelafs
2017-03-04 22:02:02 +01:00
TAHOELAFS_CONFIG=/home/tahoelafs/data/tahoe.cfg
if [ ! -f $TAHOELAFS_CONFIG ]; then
exit 62831
fi
2017-03-04 21:45:19 +01:00
# create an onion address
2017-03-04 00:25:38 +01:00
TAHOELAFS_ONION_HOSTNAME=$(add_onion_service tahoelafs ${TAHOELAFS_PORT} ${TAHOELAFS_ONION_PORT})
tahoelafs_setup_config $TAHOELAFS_CONFIG
2017-03-04 21:45:19 +01:00
# create a daemon
TAHOELAFS_DAEMON_FILE=/etc/systemd/system/tahoelafs.service
echo '[Unit]' > $TAHOELAFS_DAEMON_FILE
echo 'Description=Tahoe-LAFS introducer' >> $TAHOELAFS_DAEMON_FILE
echo 'After=syslog.target' >> $TAHOELAFS_DAEMON_FILE
echo 'After=network.target' >> $TAHOELAFS_DAEMON_FILE
echo '' >> $TAHOELAFS_DAEMON_FILE
echo '[Service]' >> $TAHOELAFS_DAEMON_FILE
echo 'Type=simple' >> $TAHOELAFS_DAEMON_FILE
echo "User=tahoelafs" >> $TAHOELAFS_DAEMON_FILE
echo "Group=tahoelafs" >> $TAHOELAFS_DAEMON_FILE
2017-03-04 19:18:07 +01:00
echo "WorkingDirectory=/home/tahoelafs/tahoelafs" >> $TAHOELAFS_DAEMON_FILE
2017-03-05 00:31:47 +01:00
echo "ExecStart=/home/tahoelafs/tahoelafs/venv/bin/tahoe start /home/tahoelafs/data; /home/tahoelafs/tahoelafs/venv/bin/tahoe run /home/tahoelafs/data" >> $TAHOELAFS_DAEMON_FILE
2017-03-04 22:02:02 +01:00
echo "ExecStop=/home/tahoelafs/tahoelafs/venv/bin/tahoe stop /home/tahoelafs/data" >> $TAHOELAFS_DAEMON_FILE
echo 'Restart=on-failure' >> $TAHOELAFS_DAEMON_FILE
echo "Environment=\"USER=tahoelafs\" \"HOME=/home/tahoelafs\"" >> $TAHOELAFS_DAEMON_FILE
echo '' >> $TAHOELAFS_DAEMON_FILE
echo '[Install]' >> $TAHOELAFS_DAEMON_FILE
echo 'WantedBy=multi-user.target' >> $TAHOELAFS_DAEMON_FILE
systemctl enable tahoelafs
systemctl daemon-reload
systemctl start tahoelafs
2017-03-03 19:48:33 +01:00
set_completion_param "tahoelafs commit" "$TAHOELAFS_COMMIT"
2017-03-05 13:09:45 +01:00
if [ ! -d /var/www/tahoelafs ]; then
mkdir -p /var/www/tahoelafs/htdocs
fi
tahoelafs_nginx_site=/etc/nginx/sites-available/tahoelafs
echo 'server {' > $tahoelafs_nginx_site
echo " listen 127.0.0.1:$TAHOELAFS_ONION_PORT default_server;" >> $tahoelafs_nginx_site
echo " server_name $TAHOELAFS_ONION_HOSTNAME;" >> $tahoelafs_nginx_site
echo '' >> $tahoelafs_nginx_site
function_check nginx_disable_sniffing
nginx_disable_sniffing tahoelafs
echo '' >> $tahoelafs_nginx_site
echo ' # Logs' >> $tahoelafs_nginx_site
echo ' access_log /dev/null;' >> $tahoelafs_nginx_site
echo ' error_log /dev/null;' >> $tahoelafs_nginx_site
echo '' >> $tahoelafs_nginx_site
echo ' # Root' >> $tahoelafs_nginx_site
echo " root /var/www/tahoelafs/htdocs;" >> $tahoelafs_nginx_site
echo '' >> $tahoelafs_nginx_site
echo ' location / {' >> $tahoelafs_nginx_site
function_check nginx_limits
nginx_limits tahoelafs '15m'
echo ' rewrite /(.*) /$1 break;' >> $tahoelafs_nginx_site
echo ' proxy_set_header X-Real-IP $remote_addr;' >> $tahoelafs_nginx_site
echo ' proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;' >> $tahoelafs_nginx_site
echo ' proxy_set_header Host $http_host;' >> $tahoelafs_nginx_site
echo ' proxy_set_header X-NginX-Proxy true;' >> $tahoelafs_nginx_site
echo " proxy_pass http://localhost:${TAHOELAFS_WEB_PORT};" >> $tahoelafs_nginx_site
echo ' proxy_redirect off;' >> $tahoelafs_nginx_site
echo ' }' >> $tahoelafs_nginx_site
echo '}' >> $tahoelafs_nginx_site
function_check nginx_ensite
nginx_ensite tahoelafs
APP_INSTALLED=1
2016-08-28 00:40:21 +02:00
}
# NOTE: deliberately no exit 0